# -*- coding: utf-8 -*-
from Preset.Model.PartBase import PartBase
from Preset.Model.GameObject import registerGenericClass


@registerGenericClass("BPart")
class BPart(PartBase):
	def __init__(self):
		super(BPart, self).__init__()
		# 零件名称
		self.name = "B"
		# 帧数变量用于之后逻辑判断
		self.tickIndex = 0

	def InitClient(self):
		pass

	def InitServer(self):
		pass

	def TickClient(self):
		self.tickIndex += 1
		if self.tickIndex == 660:
			self.NotifyToServer("PartEventB", "from player {} part {}_TickClient_NotifyToServer_{}".format(self.GetLocalPlayerId(), self.name, self.tickIndex))
			# 用作对比
			self.BroadcastEvent("PartEventB", "from player {} part {}_TickClient_BroadcastEvent_{}".format(self.GetLocalPlayerId(), self.name, self.tickIndex))
			self.BroadcastPresetSystemEvent("PresetSystemEvent", "from player {} part {}_TickClient_BroadcastPresetSystemEvent_{}".format(self.GetLocalPlayerId(), self.name, self.tickIndex))

	def TickServer(self):
		self.tickIndex += 1
		if self.tickIndex % 600 == 60:
			self.BroadcastEvent("PartEventB", "from player {} part {}_TickServer_BroadcastEvent_{}".format(self.GetLocalPlayerId(), self.name, self.tickIndex))
			self.BroadcastPresetSystemEvent("PresetSystemEvent", "from player {} part {}_TickServer_BroadcastPresetSystemEvent_{}".format(self.GetLocalPlayerId(), self.name, self.tickIndex))

	def DestroyClient(self):
		"""
		@classify_path 预设对象/零件/零件PartBase
		@state 1.23.0 新增 客户端的零件对象销毁逻辑入口
		@description 客户端的零件对象销毁逻辑入口
		"""
		pass

	def DestroyServer(self):
		pass
