# -*- coding: utf-8 -*-
from Preset.Model.PartBase import PartBase
from Preset.Model.GameObject import registerGenericClass


@registerGenericClass("CPart")
class CPart(PartBase):
	def __init__(self):
		super(CPart, self).__init__()
		# 零件名称
		self.name = "C"
		# 帧数变量用于之后逻辑判断
		self.tickIndex = 0

	def InitClient(self):
		"""
		@classify_path 预设对象/零件/零件PartBase
		@state 1.23.0 新增 客户端的零件对象初始化入口
		@description 客户端的零件对象初始化入口
		"""
		pass

	def InitServer(self):
		"""
		@classify_path 预设对象/零件/零件PartBase
		@state 1.23.0 新增 服务端的零件对象初始化入口
		@description 服务端的零件对象初始化入口
		"""
		pass

	def TickClient(self):
		"""
		@classify_path 预设对象/零件/零件PartBase
		@state 1.23.0 新增 客户端的零件对象逻辑驱动入口
		@description 客户端的零件对象逻辑驱动入口
		"""
		pass

	def TickServer(self):
		self.tickIndex += 1
		if self.tickIndex % 600 == 60:
			self.BroadcastEvent("PartEventC", "from player {} part {}_TickServer_BroadcastEvent_{}".format(self.GetLocalPlayerId(), self.name, self.tickIndex))
			self.BroadcastPresetSystemEvent("PresetSystemEvent", "from player {} part {}_TickServer_BroadcastPresetSystemEvent_{}".format(self.GetLocalPlayerId(), self.name, self.tickIndex))

	def DestroyClient(self):
		"""
		@classify_path 预设对象/零件/零件PartBase
		@state 1.23.0 新增 客户端的零件对象销毁逻辑入口
		@description 客户端的零件对象销毁逻辑入口
		"""
		pass

	def DestroyServer(self):
		"""
		@classify_path 预设对象/零件/零件PartBase
		@state 1.23.0 新增 服务端的零件对象销毁逻辑入口
		@description 服务端的零件对象销毁逻辑入口
		"""
		pass
